(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-overflow-shadow', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-overflow-shadow'] = {}, global.ng.core));
}(this, function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxOverflowShadowDirective = /** @class */ (function () {
        function NgxOverflowShadowDirective(renderer, elementRef) {
            this.renderer = renderer;
            this.elementRef = elementRef;
            this.defaultBottomShadow = 'os_default-bottom-shadow';
        }
        /**
         * @return {?}
         */
        NgxOverflowShadowDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var nativeElement = this.elementRef.nativeElement;
            this.observer = new IntersectionObserver(this.callback.bind(this), { root: nativeElement });
            this.createBottomPlaceholderDiv(nativeElement);
            this.createBottomShadowDiv(nativeElement);
        };
        /**
         * @return {?}
         */
        NgxOverflowShadowDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.observer.disconnect();
        };
        /**
         * @private
         * @param {?} nativeElement
         * @return {?}
         */
        NgxOverflowShadowDirective.prototype.createBottomPlaceholderDiv = /**
         * @private
         * @param {?} nativeElement
         * @return {?}
         */
        function (nativeElement) {
            /** @type {?} */
            var bottomPlaceholderDiv = this.renderer.createElement('div');
            this.renderer.appendChild(nativeElement, bottomPlaceholderDiv);
            this.observer.observe(bottomPlaceholderDiv);
        };
        /**
         * @private
         * @param {?} nativeElement
         * @return {?}
         */
        NgxOverflowShadowDirective.prototype.createBottomShadowDiv = /**
         * @private
         * @param {?} nativeElement
         * @return {?}
         */
        function (nativeElement) {
            this.bottomShadowDiv = this.renderer.createElement('div');
            this.renderer.appendChild(nativeElement, this.bottomShadowDiv);
        };
        /**
         * @private
         * @param {?} entries
         * @return {?}
         */
        NgxOverflowShadowDirective.prototype.callback = /**
         * @private
         * @param {?} entries
         * @return {?}
         */
        function (entries) {
            var isIntersecting = entries[0].isIntersecting;
            if (isIntersecting) {
                this.renderer.removeClass(this.bottomShadowDiv, this.defaultBottomShadow);
            }
            else {
                this.renderer.addClass(this.bottomShadowDiv, this.defaultBottomShadow);
            }
        };
        NgxOverflowShadowDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxOverflowShadow]'
                    },] }
        ];
        /** @nocollapse */
        NgxOverflowShadowDirective.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ElementRef }
        ]; };
        NgxOverflowShadowDirective.propDecorators = {
            defaultBottomShadow: [{ type: core.Input }]
        };
        return NgxOverflowShadowDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxOverflowShadowModule = /** @class */ (function () {
        function NgxOverflowShadowModule() {
        }
        NgxOverflowShadowModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NgxOverflowShadowDirective],
                        imports: [],
                        exports: [NgxOverflowShadowDirective]
                    },] }
        ];
        return NgxOverflowShadowModule;
    }());

    exports.NgxOverflowShadowDirective = NgxOverflowShadowDirective;
    exports.NgxOverflowShadowModule = NgxOverflowShadowModule;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-overflow-shadow.umd.js.map
